// $Id: imageeditor.js,v 1.1 2011/02/18 12:31:27 duozersk Exp $

Drupal.behaviors.imageeditor = function(context) {
  
  var $imageeditor_divs_existing = $('.imageeditor.imageeditor-existing', context);
  $imageeditor_divs_existing.find('div.pixlr-editor').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.editor_url,
        'image': url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials,
      });
    }
  );
  $imageeditor_divs_existing.find('div.pixlr-express').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.express_url,
        'image': url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials,
      });
    }
  );
  $imageeditor_divs_existing.find('div.picnik').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.picnik.url,
        '_apikey': Drupal.settings.imageeditor.picnik['api_key'],
        '_import': url,
        '_export': Drupal.settings.imageeditor.picnik['export'] + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        '_export_agent': 'browser',
        '_export_method': 'GET',
        '_export_title': 'Save to ' + Drupal.settings.imageeditor.site_name,
        '_host_name': Drupal.settings.imageeditor.site_name,
        '_replace': 'ask', //Picnik will ask: replace an image or create a new one
        '_imageid': field_name + '_' + delta,
        '_original_thumb': $(this).parent().parent().parent().find('.imagefield-preview').find('img').attr('src'),
        '_close_target': Drupal.settings.imageeditor.picnik.exit,
        //'_expand_button': 'true' //adds Expand button and calls onPicknikExpand function
        '_locale': Drupal.settings.imageeditor.picnik.loc,
      });
    }
  );
  $imageeditor_divs_existing.find('div.aviary-feather').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor_first_run = 'yes';
      aviaryeditor($(this).parent().parent().parent().find('.imagefield-preview').find('img').attr('id', field_name + '_' + delta).attr('id'), url);
    }
  );
  $imageeditor_divs_existing.find('div.sumopaint').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.sumopaint.url,
        'key': Drupal.settings.imageeditor.sumopaint['api_key'],
        'url': url,
        'service': 'Save to ' + Drupal.settings.imageeditor.site_name,
        'target': Drupal.settings.imageeditor.sumopaint.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        //'opt': 'test',
      });
    }
  );
  $imageeditor_divs_existing.find('div.fotoflexer').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.fotoflexer.url,
        'ff_image_url': url,
        'ff_callback_url': Drupal.settings.imageeditor.fotoflexer.callback_url + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'ff_cancel_url': Drupal.settings.imageeditor.fotoflexer.cancel_url,
        'ff_lang': Drupal.settings.imageeditor.fotoflexer.lang,
      });
    }
  );
  $imageeditor_divs_existing.find('div.flauntr-styler').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var url = $(this).parent().parent().find('.url').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.flauntr_styler.url,
        'app': 'styler',
        'url': url,
      });
    }
  );
  $imageeditor_divs_existing.find('div.pixlr-upload').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      var $url = $(this).parent().parent().find('.url');
      var filepath = $(this).parent().parent().find('.filepath').attr('value');
      $.ajax({
        type: 'GET',
        url: Drupal.settings.imageeditor.pixlr_upload.upload,
        async: false, // explicitly need the user to wait while we load...
        data: {'filepath': filepath},
        success: function(data) {$url.attr('value', data);},
        error: function(msg) {alert("Failed uploading to Pixlr: " + msg);},
      });
    }
  );
  $imageeditor_divs_existing.find('div.imageshack-upload').click(
      function() {
        var field_name = $(this).parent().parent().find('.field-name').attr('value');
        var delta = $(this).parent().parent().find('.delta').attr('value');
        var $url = $(this).parent().parent().find('.url');
        var filepath = $(this).parent().parent().find('.filepath').attr('value');
        $.ajax({
          type: 'GET',
          url: Drupal.settings.imageeditor.imageshack_upload.upload,
          async: false, // explicitly need the user to wait while we load...
          data: {'filepath': filepath},
          success: function(data) {$url.attr('value', data);},
          error: function(msg) {alert("Failed uploading to Imageshack: " + msg);}
        });
      }
    );
  
  //to show as overlay over the image preview
  $('div.widget-preview', context).each(
    function(index) {
      var field_name = $(this).find('.imageeditor').find('.field-name').attr('value');
      if (Drupal.settings.imageeditor[field_name]['imageeditor_icons_position'] == 1) {
        $(this).css('position', 'relative').hover(
          function() {
            $(this).find('.imageeditor').css({'position': 'absolute', 'top': 0}).show();
          },
          function() {
            $(this).find('.imageeditor').hide();
          }
        ).find('.imageeditor').hide();
      }
    }
  );
  
  var $imageeditor_divs_new = $('.imageeditor.imageeditor-new', context);
  $imageeditor_divs_new.find('div.pixlr-editor').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.editor_url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials,
      });
    }
  );
  $imageeditor_divs_new.find('div.pixlr-express').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.pixlr.express_url,
        'target': Drupal.settings.imageeditor.pixlr.target + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'exit': Drupal.settings.imageeditor.pixlr.exit,
        'loc': Drupal.settings.imageeditor.pixlr.loc,
        'referrer': 'Drupal: ' + Drupal.settings.imageeditor.site_name + ' (' + Drupal.settings.imageeditor.base_url + ')',
        'credentials': Drupal.settings.imageeditor.pixlr.credentials,
      });
    }
  );
  $imageeditor_divs_new.find('div.picnik').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.overlay.show({
        'imageeditor_url': Drupal.settings.imageeditor.picnik.url,
        '_apikey': Drupal.settings.imageeditor.picnik['api_key'],
        '_export': Drupal.settings.imageeditor.picnik['export'] + '/' + field_name + '/' + delta + '/1/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        '_export_agent': 'browser',
        '_export_method': 'GET',
        '_export_title': 'Save to ' + Drupal.settings.imageeditor.site_name,
        '_host_name': Drupal.settings.imageeditor.site_name,
        '_close_target': Drupal.settings.imageeditor.picnik.exit,
        //'_expand_button': 'true' //adds Expand button and calls onPicknikExpand function
        '_locale': Drupal.settings.imageeditor.picnik.loc,
      });
    }
  );
  $imageeditor_divs_new.find('div.sumopaint').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.sumopaint.url,
        'key': Drupal.settings.imageeditor.sumopaint['api_key'],
        'service': 'Save to ' + Drupal.settings.imageeditor.site_name,
        'target': Drupal.settings.imageeditor.sumopaint.target + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        //'opt': 'test',
      });
    }
  );
  $imageeditor_divs_new.find('div.fotoflexer').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.fotoflexer.url,
        'ff_callback_url': Drupal.settings.imageeditor.fotoflexer.callback_url + '/' + field_name + '/' + delta + '/0/' + Drupal.settings.imageeditor[field_name]['imageeditor_replace'] + '/1',
        'ff_cancel_url': Drupal.settings.imageeditor.fotoflexer.cancel_url,
        'ff_lang': Drupal.settings.imageeditor.fotoflexer.lang,
      });
    }
  );
  $imageeditor_divs_new.find('div.flauntr-styler').click(
    function() {
      var field_name = $(this).parent().parent().find('.field-name').attr('value');
      var delta = $(this).parent().parent().find('.delta').attr('value');
      imageeditor.popup.show({
        'imageeditor_url': Drupal.settings.imageeditor.flauntr_styler.url,
        'app': 'styler',
      });
    }
  );
}

Feather_OnSave = function(imageId, newurl) {
  imageeditor_url = newurl;
  if (imageeditor_first_run != 'no') {
    imageeditor_id = 'edit-' + imageId.replace(/_/g, '-');
    imageeditor_field_name = imageId.replace(/^(.*)_.*$/, '$1');
    if (Drupal.settings.imageeditor[imageeditor_field_name]['imageeditor_replace']) {
      $('input[name="' + imageId + '_filefield_remove"]').mousedown();
    }
    else {
      $('input[name="' + imageeditor_field_name + '_add_more"]').mousedown();
    }
    imageeditor_first_run = 'no';
  }
};

Feather_OnClose = function() {
  if ((typeof(imageeditor_field_name) != 'undefined') && (imageeditor_field_name != 'undefined')) {
    if (Drupal.settings.imageeditor[imageeditor_field_name]['imageeditor_replace']) {
      $('a[id="' + imageeditor_id + '-remote-source"]').click();
      $('input[id="' + imageeditor_id + '-filefield-remote-url"]').val(imageeditor_url);
      $('input[id="' + imageeditor_id + '-filefield-remote-transfer"]').mousedown();
    }
    else {
      starts_with = 'edit-' + imageeditor_field_name.replace(/_/g, '-');
      $('a[id^="' + starts_with + '-"][id$="-remote-source"]:first').click();
      $('input[id^="' + starts_with + '-"][id$="-filefield-remote-url"]:first').val(imageeditor_url);
      $('input[id^="' + starts_with + '-"][id$="-filefield-remote-transfer"]:first').mousedown();
    }
    imageeditor_url = 'undefined';
    imageeditor_id = 'undefined';
    imageeditor_field_name = 'undefined';
    imageeditor_first_run = 'undefined';
  }
}

var imageeditor = function() {
  function windowSize() {
    var w = 0, h = 0;
    if(!(document.documentElement.clientWidth == 0)) {
      w = document.documentElement.clientWidth;
      h = document.documentElement.clientHeight;
    }
    else {
      w = document.body.clientWidth;
      h = document.body.clientHeight;
    }
    return {width:w,height:h};
  }
  function buildUrl(opt) {
    var url = opt.imageeditor_url;
    var first_attr = 'yes';
    for(var attribute in opt) {
      if(attribute !== 'imageeditor_url') {
        if (first_attr == 'yes') {
          url += "?"+ attribute +"="+ escape(opt[attribute]);
          first_attr = 'no';
        }
        else {
          url += "&"+ attribute +"="+ escape(opt[attribute]);
        }
      }
    }
    return url;
  }
  var bo = {
    ie: window.ActiveXObject,
    ie6: window.ActiveXObject && (document.implementation != null) && (document.implementation.hasFeature != null) && (window.XMLHttpRequest == null),
    quirks: document.compatMode==='BackCompat'
  }
  return {
    overlay: {
      show: function(options) {
        var iframe = document.createElement('iframe'), 
        div = imageeditor.overlay.div = document.createElement('div'),
        idiv = imageeditor.overlay.idiv = document.createElement('div');
        
        div.style.background = '#696969';
        div.style.opacity = 0.8;
        div.style.filter = 'alpha(opacity=80)';
        
        if((bo.ie && bo.quirks) || bo.ie6) {
          var size = windowSize();
          div.style.position = 'absolute';
          div.style.width = size.width + 'px';
          div.style.height = size.height + 'px';
          div.style.setExpression('top', "(t=document.documentElement.scrollTop||document.body.scrollTop)+'px'");
          div.style.setExpression('left', "(l=document.documentElement.scrollLeft||document.body.scrollLeft)+'px'");
        }
        else {
          div.style.width = '100%';
          div.style.height = '100%';
          div.style.top = '0';
          div.style.left = '0';
          div.style.position = 'fixed';
        }
        div.style.zIndex = 99998;

        idiv.style.border = '1px solid #2c2c2c';
        if((bo.ie && bo.quirks) || bo.ie6) {
          idiv.style.position = 'absolute';
          idiv.style.setExpression('top', "20+((t=document.documentElement.scrollTop||document.body.scrollTop))+'px'");
          idiv.style.setExpression('left', "20+((l=document.documentElement.scrollLeft||document.body.scrollLeft))+'px'");
        }
        else {
          idiv.style.position = 'fixed';
          idiv.style.top = '20px';
          idiv.style.left = '20px';
        }
        idiv.style.zIndex = 99999;                         
        
        document.body.appendChild(div);
        document.body.appendChild(idiv);
        
        iframe.style.width = (div.offsetWidth - 40) +'px';
        iframe.style.height = (div.offsetHeight - 40) +'px';
        iframe.style.border = '1px solid #b1b1b1';
        iframe.style.backgroundColor = '#606060';
        iframe.style.display = 'block';
        iframe.frameBorder = 0;
        iframe.src = buildUrl(options);
        iframe.name = 'imageeditor_iframe';
        
        idiv.appendChild(iframe);
      },
      hide: function() {
        if(imageeditor.overlay.idiv && imageeditor.overlay.div) {
          document.body.removeChild(imageeditor.overlay.idiv);
          document.body.removeChild(imageeditor.overlay.div);
        }
      }
    },
    popup: {
      show: function(options) {
        popup_window = window.open(buildUrl(options), 'imageeditor', 'location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no,channelmode=yes,fullscreen=yes');
        popup_window.focus();
      }
    }
  }
}();